# Generated by Django 3.2.13 on 2022-11-04 10:45

from django.db import migrations, models
import django.db.models.deletion
import django_jsonform.models.fields


def complete_existing_registrations(apps, schema_editor):
    Registration = apps.get_model('applications', 'Registration')  # noqa
    Registration.objects.update(is_completed=True)


class Migration(migrations.Migration):

    dependencies = [
        ('applications', '0020_auto_20220902_1402'),
    ]

    operations = [
        migrations.CreateModel(
            name='InsielConfig',
            fields=[
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='created at')),
                ('modified_at', models.DateTimeField(auto_now=True, verbose_name='modified at')),
                ('id', models.BigAutoField(primary_key=True, serialize=False)),
                ('description', models.CharField(blank=True, max_length=128, verbose_name='description')),
                ('is_active', models.BooleanField(verbose_name='active')),
                ('login_url', models.URLField(verbose_name='Login URL')),
                ('registry_url', models.URLField(verbose_name='Protocol Web service URL')),
                ('file_transfer_url', models.URLField(verbose_name='File transfer Web service URL')),
                ('client_id', models.CharField(max_length=32, verbose_name='Client id')),
                ('client_secret', models.CharField(max_length=32, verbose_name='Client secret')),
                ('grant_type', models.CharField(default='client_credentials', max_length=32, verbose_name='Grant type')),
                ('user_code', models.CharField(max_length=32, verbose_name="User's code")),
                ('user_password', models.CharField(max_length=32, verbose_name="User's password")),
                ('operating_office_code', models.CharField(max_length=32, null=True, verbose_name="operating office's code")),
                ('office_code', models.CharField(max_length=32, verbose_name="Office's code")),
                ('office_registry', models.CharField(max_length=32, verbose_name="Office's registry")),
                ('internal_offices_codes', django_jsonform.models.fields.ArrayField(base_field=models.CharField(max_length=32, verbose_name="Internal office's code"), size=None, verbose_name="internal office's codes")),
                ('register_code', models.CharField(help_text='Right aligned levels: ex: "  1  2  3"', max_length=32, null=True, verbose_name='Register code')),
                ('prog_doc', models.CharField(help_text='This field is required if prog_movi is defined', max_length=32, null=True, verbose_name='Register prog doc')),
                ('prog_movi', models.CharField(help_text='This field is required if prog_doc is defined', max_length=32, null=True, verbose_name='Register prog movi')),
            ],
        ),
        migrations.AddField(
            model_name='registration',
            name='is_completed',
            field=models.BooleanField(default=False, verbose_name='Completed'),
        ),
        migrations.RunPython(complete_existing_registrations, reverse_code=migrations.RunPython.noop),
        migrations.AddField(
            model_name='registration',
            name='registration_data',
            field=models.JSONField(null=True, verbose_name='Registration data'),
        ),
        migrations.AlterField(
            model_name='halleycloudconfig',
            name='institution_office_ids',
            field=django_jsonform.models.fields.ArrayField(base_field=models.PositiveIntegerField(), size=1, verbose_name='institution office IDs'),
        ),
        migrations.AlterField(
            model_name='halleyconfig',
            name='institution_office_ids',
            field=django_jsonform.models.fields.ArrayField(base_field=models.PositiveIntegerField(), size=1, verbose_name='institution office IDs'),
        ),
        migrations.AlterField(
            model_name='pitreconfig',
            name='receiver_codes',
            field=django_jsonform.models.fields.ArrayField(base_field=models.CharField(max_length=32, verbose_name='receiver code'), size=None, verbose_name='receiver codes'),
        ),
        migrations.AlterField(
            model_name='registration',
            name='date',
            field=models.DateTimeField(null=True, verbose_name='date'),
        ),
        migrations.AlterField(
            model_name='registration',
            name='number',
            field=models.CharField(max_length=64, null=True, verbose_name='number'),
        ),
        migrations.AlterField(
            model_name='registrationevent',
            name='provider',
            field=models.CharField(choices=[('datagraph', 'datagraph'), ('dedagroup', 'dedagroup'), ('halley', 'halley'), ('halley_cloud', 'halley_cloud'), ('maggioli', 'maggioli'), ('pitre', 'pitre'), ('insiel', 'insiel')], max_length=32, verbose_name='provider'),
        ),
        migrations.AlterField(
            model_name='service',
            name='provider',
            field=models.CharField(choices=[('datagraph', 'datagraph'), ('dedagroup', 'dedagroup'), ('halley', 'halley'), ('halley_cloud', 'halley_cloud'), ('maggioli', 'maggioli'), ('pitre', 'pitre'), ('insiel', 'insiel')], max_length=32, verbose_name='provider'),
        ),
        migrations.AddConstraint(
            model_name='registration',
            constraint=models.CheckConstraint(check=models.Q(models.Q(('is_completed', False)), models.Q(('number__isnull', False), ('date__isnull', False)), _connector='OR'), name='applications_registration_number_and_folder_exists_if_completed'),
        ),
        migrations.AddField(
            model_name='insielconfig',
            name='service',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='insiel_configs', to='applications.service', verbose_name='service'),
        ),
        migrations.AddConstraint(
            model_name='insielconfig',
            constraint=models.UniqueConstraint(condition=models.Q(('is_active', True)), fields=('service', 'is_active'), name='applications_insielconfig_unique_service_is_active_true'),
        ),
        migrations.AddConstraint(
            model_name='insielconfig',
            constraint=models.CheckConstraint(check=models.Q(models.Q(('register_code__isnull', False), ('prog_doc__isnull', True), ('prog_movi__isnull', True)), models.Q(('register_code__isnull', True), ('prog_doc__isnull', False), ('prog_movi__isnull', False)), _connector='OR'), name='applications_insielconfig_valid_folder_configuration'),
        ),
    ]
